import { Socket } from "net";

const OPEN = 1;//0x01
const CLOSE = 2;//0x02
let socket = new Socket();

let sendBufferData = Int8Array.from([-86,/*0xaa,*/0X0F, 0X01, 0X01, 0X01, 0X01, 0X01, 0X01, 0X01, 0X01, 0X01, 0X01, 0X01, 0X01, 0X01, 0X01, 0X01, 0X01, 0X01, -69/*0xbb,*/]);

socket.connect(8080, "192.168.1.240", () =>
{
    //发送请求得到灯具的状态(如果得不到,可能需要多发送几次? 未测试)
    sendBufferData[1] = 0x1e;
    socket.write(new Uint8Array(sendBufferData));
    console.log("已经连接");
});

let lightStatus: Buffer;
socket.on("data", buff =>
{
    //避免粘包
    for (let i = 0; i * 20 < buff.length; i++)
        if (buff[i * 20 + 1] === 12)
        {
            console.log("获得灯具的状态");
            lightStatus = buff.subarray(i * 20 + 2, i * 20 + 18);
            console.log(lightStatus);
        }
});

function OpenAll()
{
    sendBufferData[1] = 10;//0x0a\
    for (let i = 0; i < 16; i++)
        sendBufferData[i + 2] = OPEN;
    socket.write(new Uint8Array(sendBufferData));
}

function CloseAll()
{
    sendBufferData[1] = 11;//0x0b
    for (let i = 0; i < 16; i++)
        sendBufferData[i + 2] = CLOSE;
    socket.write(new Uint8Array(sendBufferData));
}

function Open(lightIndex: number)
{
    sendBufferData[1] = 0x0f;//0x0b
    sendBufferData[2] = lightIndex;
    sendBufferData[3] = OPEN;
    socket.write(new Uint8Array(sendBufferData));
}

function Close(lightIndex: number)
{
    sendBufferData[1] = 0x0f;//0x0b
    sendBufferData[2] = lightIndex;
    sendBufferData[3] = CLOSE;
    socket.write(new Uint8Array(sendBufferData));
}

globalThis.OpenAll = OpenAll;
globalThis.CloseAll = CloseAll;
globalThis.Open = Open;
globalThis.Close = Close;
